SystemOrganization addCategory: #'Seaside-Tests-Development'!

WAContextTestCase subclass: #WADispatcherComponentTest
	instanceVariableNames: 'rootHanlder childHanlder configApplication normalApplication childApplication configComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Development'!

!WADispatcherComponentTest methodsFor: 'private' stamp: 'pmm 5/11/2008 22:30'!
handlersToPush
	^super handlersToPush, (Array
		with: configApplication
		with: (WASession new setParent: configApplication; yourself))! !

!WADispatcherComponentTest methodsFor: 'private' stamp: 'lr 9/13/2008 11:40'!
requestContextWithUrl: aString
	^ WARequestContext
		server: self
		request: (WARequest
			method: 'GET'
			url: aString
			headers: Dictionary new
			fields: Dictionary new
			cookies: Array new
			remoteAddress: '127.0.0.1')! !

!WADispatcherComponentTest methodsFor: 'running' stamp: 'MAD 9/13/2008 16:27'!
setUp
	super setUp.
	rootHanlder := WADispatcher named: 'seaside'.
	childHanlder := WADispatcher register: 'child' in: rootHanlder.
	
	configApplication := WAApplication register: 'config' in: rootHanlder.
	configApplication configuration addParent: WARenderLoopConfiguration instance.
	configApplication preferenceAt: #rootClass put: WADispatcherEditor.
	
	normalApplication := WAApplication register: 'counter' in: childHanlder.
	normalApplication configuration addParent: WARenderLoopConfiguration instance.
	normalApplication preferenceAt: #rootClass put: WADispatcherEditor! !

!WADispatcherComponentTest methodsFor: 'testing' stamp: 'lr 9/13/2008 11:40'!
testChildApplication
	| context |
	configComponent := WADispatcherEditor on: rootHanlder.
	
	context := self requestContextWithUrl: '/seaside/config/child/counter'.
	
	configComponent initialRequest: context request.
	self assert: configComponent handler == childHanlder! !

!WADispatcherComponentTest methodsFor: 'testing' stamp: 'lr 9/13/2008 11:41'!
testNestedDispatcher
	| context |
	configComponent := WADispatcherEditor on: rootHanlder.
	context := self requestContextWithUrl: '/seaside/config/child'.
	
	configComponent initialRequest: context request.
	self assert: configComponent handler == childHanlder! !
